<template>
  <div>
    <div class="row">
      <div class="col d-flex justify-content-end">
        <a-button type="dashed" @click="getUsers()" class="d-flex align-items-center">
          <a-icon type="reload" />Recarregar
        </a-button>
        <a-button
          type="primary"
          @click="handleShowDrawerForm"
          class="d-flex d-flex align-items-center"
        >
          <a-icon type="plus" />Cadastrar novo
        </a-button>
      </div>
    </div>
    <users-table
      :users="users"
      :loading="loading"
      @emit-show-drawer-form="handleShowDrawerForm"
      @emit-show-drawer-view="handleShowDrawerView"
      @emit-show-drawer-edit="handleShowDrawerEdit"
    />
    <users-drawer-form
      :showDrawer="drawerForm"
      :user="user"
      @emit-save-user="postUsers"
      @emit-close-drawer="handleCloseDrawerForm"
    />
    <users-drawer-view
      :drawerView="drawerView"
      :user="user"
      @emit-close-drawer="handleCloseDrawerView"
    />
  </div>
</template>

<script>
import Api from "@/services/api";
import User from "@/model/user/user";
import UsersTable from "@/components/page-components/users/users-table";
import UsersDrawerForm from "@/components/page-components/users/users-drawer-form";
import UsersDrawerView from "@/components/page-components/users/users-drawer-view";
export default {
  components: { UsersTable, UsersDrawerForm, UsersDrawerView },
  data() {
    return {
      drawerForm: false,
      drawerView: false,
      closeDrawerView: false,
      closeDrawerForm: false,
      loading: false,
      users: [],
      user: [],
    };
  },
  mounted() {
    this.getUsers();
  },
  methods: {
    async getUsers() {
      this.loading = true;
      try {
        const response = await Api.getUsers();
        this.users = response.data;
        setTimeout(() => {
          this.loading = false;
        }, 1000);
      } catch (error) {
        console.log(error);
        this.loading = false;
      }
    },
    async postUsers(user) {
      try {
        const response = await Api.postUsers(user);
        this.users = response.data.users;
      } catch (error) {
        console.log(error);
      }
    },
    // Drawer FORM
    handleShowDrawerForm() {
      this.drawerForm = true;
      this.user = new User();
    },
    handleCloseDrawerForm(closeDrawer) {
      this.drawerForm = closeDrawer;
      this.user = new User();
    },
    // Drawer EDIT
    handleShowDrawerEdit(user) {
      this.drawerForm = true;
      this.user = user;
    },
    handleCloseDrawerEdit(closeDrawer) {
      this.drawerForm = closeDrawer;
      this.user = new User();
    },
    // Drawer VIEW
    handleShowDrawerView(user) {
      this.user = user;
      this.drawerView = true;
    },
    handleCloseDrawerView(closeDrawer) {
      this.drawerView = closeDrawer;
    },
  },
};
</script>
